import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ball here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ball extends Goods
{
    /**
     * Act - do whatever the ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    int x,y;
    
    double velocity;
    double theta; // degree at which to throw the ball.  
    double grav; // acceleration  
    double dt; // change in time.
    
    double cosine, sinus;
    
    double BOS,XSP;
    int randrotation;
    
    int color;
 
    public Ball(int ballX, int ballY, double theta, int color,int velocity)
    {
     
    XSP = ballX;
    BOS = ballY;
    
    this.color = color;
    this.velocity  = velocity; 
    this.theta = theta; // degree at which to throw the ball.  
    grav = 9.8; // acceleration  
    dt = 0; // change in time. 

    
    //velocity=100;
    
    cosine = Math.cos(Math.toRadians(theta));
    sinus = Math.sin(Math.toRadians(theta));
    
    randrotation = Greenfoot.getRandomNumber(20);
    
    }
    
    public void act() 
    {
     
    
        dt = dt + .1;
        x = (int) (XSP + ((velocity * cosine) * dt));
        y = (int) (BOS - ((velocity * sinus) * dt - 0.5 * grav * dt * dt));
     
        setLocation( x, y);
        
        if(getY()>=getWorld().getHeight()-(getImage().getHeight()/2-1))
        {
            getWorld().removeObject(this);
        }    
        else if(AtWorldEdge())
        {
            //getWorld().removeObject(this);
            //Ball ball = new Ball(); 
            getImage().setTransparency(0);
        }
        else
        {
            getImage().setTransparency(255);
        }
        turn(randrotation);
        
        try{
            Brick br=(Brick)getOneIntersectingObject(Brick.class);
            if(br!=null)
            {
                if(br.color==this.color && this.color==3)
                {
                    Greenfoot.playSound("win.wav");
                    Awal awal = new Awal();
                    awal.setImage("win.gif");
                    getWorld().addObject(awal,getWorld().getWidth()/2,getWorld().getHeight()/2);
                    Greenfoot.stop();
                }    
                else if(br.color==this.color)
                {   
                    Greenfoot.playSound("boom.wav");
                    getWorld().removeObject(br);
                }
                else
                {
                    Greenfoot.playSound("bloop1.wav");    
                }
                getWorld().removeObject(this);
            }    
        }catch(Exception e)
        {
            
        }    
        
    }
    
    public boolean disappear()
    {
        if(getY()<0 || getY() > getWorld().getHeight() -1 )
            return true;
        return false;
    }
    
    public boolean AtWorldEdge()  
    {  
        double w=getImage().getWidth()/2,h=getImage().getHeight()/2; 
        return getX()<1 || getY()<1 || getX()>getWorld().getWidth()-(w-1) ;  
    } 
}
